use DFA::Cellular;

my $dfa = DFA::Cellular->new(40,20,<<INIT);
****************************************
*                                      **
*    **                                **
*     *       *                        **
*       * *****                        **
*           ***                        **
*                                      **
*     * *     **                       **
*             *                        **
*                                      **
*                                      **
*                                      **
*                                      **
*                                      **
*                                      **
*                                      **
*                                      **
*                                      **
*                                      **
*****************************************
 ****************************************
INIT

$dfa->show;

$dfa->addrule(
	DFA::Cellular::Rule->new(['** ',
				  '*  '  => '*',
				  '   '
				 ])->mirror,
	DFA::Cellular::Rule->new(['***',
				  '   '  => '*',
				  '   '
				 ])->rotate,
	DFA::Cellular::Rule->new(['***',
				  '***'  => ' ',
				  '***'
				 ]),
	DFA::Cellular::Rule->new(['***',
				  '   '  => '*',
				  '***'
				 ]),
);

while (1) {
	$dfa->step;
	$dfa->show;
}
