use DFA::Cellular;

my $dfa = DFA::Cellular->new(10,10,<<INIT);
**********
*        *
* 1      *
*        *
*        *
*        *
* 2      *
*        *
*     3  *
**********
INIT

$dfa->show;

$dfa->addrule(
        DFA::Cellular::Rule->new(['1..',
                                  '...'  => '1',
                                  '...'
                                 ]),
        DFA::Cellular::Rule->new(['...',
                                  '.1.'  => ' ',
                                  '...'
                                 ]),
        DFA::Cellular::Rule->new(['...',
                                  '2..'  => '2',
                                  '...'
                                 ]),
        DFA::Cellular::Rule->new(['...',
                                  '.2.'  => ' ',
                                  '...'
                                 ]),
        DFA::Cellular::Rule->new(['...',
                                  '...'  => '3',
                                  '.3.'
                                 ]),
        DFA::Cellular::Rule->new(['...',
                                  '.3.'  => ' ',
                                  '...'
                                 ]),
);

while (1) {
        $dfa->step;
	sleep 1;
        $dfa->show;
}
